Attribute VB_Name = "TL30P"

' ItemType property constants
Global Const TLTYPE_NONE = &H0
Global Const TLTYPE_INT = &H494E
Global Const TLTYPE_LNG = &H4C4E
Global Const TLTYPE_SNG = &H534E
Global Const TLTYPE_STR = &H5354
Global Const TLTYPE_PIC = &H5450

' TListGetItemByXY function nType parameter constants
Global Const PTFIND_ITEM = 1
Global Const PTFIND_PIC = 2

' TListGetItemRect function nType parameter constants
Type RECT
        left As Integer
        top As Integer
        right As Integer
        bottom As Integer
End Type

Global Const TLGR_ITEM = &H1
Global Const TLGR_PLUSMINUS = &H2
Global Const TLGR_MARK = &H4
Global Const TLGR_PICTURE = &H8
Global Const TLGR_TEXT = &H10

' Error codes constants
Global Const TLERR_BADINDENTATION = 20101
Global Const TLERR_WRONPARAMS = 20102 ' Obselete
Global Const TLERR_ITEMNOTFOUND = 20103
Global Const TLERR_PARENTNOTEXPANDED = 20104
Global Const TLERR_INITFAULT = 20105
Global Const TLERR_CANNOTSHOW = 20106
Global Const TLERR_INVALIDSEPARATOR = 20107
Global Const TLERR_INVALIDTREEBUFFER = 20108
Global Const TLERR_BIGPICSIZE = 20109
Global Const TLERR_NOTHINGTOCOPY = 20110
Global Const TLERR_TOMANYITEMS = 20111
Global Const TLERR_TOMANYSUBITEMS = 20112
Global Const TLERR_INVALIDARGS = 20113

' TriggerEvents property constants
Global Const TL_TRIGGER_INITIAL = 0
Global Const TL_TRIGGER_COLLAPSE_FOR_ALL = 1

' ItemEditText property  constants
Global Const TL_EDITTEXT_CANCEL = &H0
Global Const TL_EDITTEXT_END = &H1
Global Const TL_EDITTEXT_BEGIN = &H2

' Clipboard property  constants
Global Const TL_CLP_COPY = 0
Global Const TL_CLP_COPYONE = 1
Global Const TL_CLP_COPYSUB = 2
Global Const TL_CLP_PASTEANDADD = 3
Global Const TL_CLP_PASTEANDINSERT = 4

' VScroll & HScroll ScrollCode parameter constants
Global Const TL_SB_BOTTOM = 7
Global Const TL_SB_ENDSCROLL = 8
Global Const TL_SB_LINEDOWN = 1
Global Const TL_SB_LINEUP = 0
Global Const TL_SB_PAGEDOWN = 3
Global Const TL_SB_PAGEUP = 2
Global Const TL_SB_THUMBPOSITION = 4
Global Const TL_SB_THUMBTRACK = 5
Global Const TL_SB_TOP = 6

' AfterEditing Options parameter constants
Global Const TL_EDCANCELLEDBY_USER = &H0
Global Const TL_EDCANCELLEDBY_PROPERTY = &H1

' RequestEditing Options parameter constants
Global Const TL_REQED_LEFT = &H0
Global Const TL_REQED_CENTER = &H1
Global Const TL_REQED_RIGHT = &H2
Global Const TL_REQED_MULTILINE = &H4
Global Const TL_REQED_UPPERCASE = &H8
Global Const TL_REQED_LOWERCASE = &H10
Global Const TL_REQED_PASSWORD = &H20
Global Const TL_REQED_AUTOVSCROLL = &H40
Global Const TL_REQED_AUTOHSCROLL = &H80
Global Const TL_REQED_READONLY = &H800
Global Const TL_REQED_STDCOLORS = &H100
Global Const TL_REQED_BORDER = &H200
Global Const TL_REQED_VSCROLLER = &H400
Global Const TL_REQED_HSCROLLER = &H2000

' TListFindItem function nFlags parameter constants
Global Const TL_FI_DONTUSECASE = &H1
Global Const TL_FI_RELAXED = &H2
Global Const TL_FI_BACKDIR = &H100
Global Const TL_FI_SELONLY = &H200
'================================================================================
' Certain function calls must be defined if used.  These declarations follow below.
#If Win16 Then
        '** These function calls should be used with the 16 bit OCX
        Declare Sub TListFreeBuffer Lib "TLIST16P.OCX" (ByVal TreeBuffer As Long)
        Declare Function TListIsValidBuffer Lib "TLIST16P.OCX" (ByVal TreeBuffer As Long) As Integer
        Declare Function TListSaveBuffer Lib "TLIST16P.OCX" (ByVal TreeBuffer As Long, ByVal nFile As Integer) As Integer
        Declare Function TListLoadBuffer Lib "TLIST16P.OCX" (TreeBuffer As Long, ByVal nFile As Integer) As Integer
        Declare Function TListCopyBuffer Lib "TLIST16P.OCX" (ByVal TreeBuffer As Long) As Integer
        Declare Function TListPasteBuffer Lib "TLIST16P.OCX" (TreeBuffer As Long) As Integer
        Declare Function TListIsClipboardFormatAvailable Lib "TLIST16P.OCX" () As Integer

#ElseIf Win32 Then
        '** These function calls should be used with the 32 bit OCX
        Declare Sub TListFreeBuffer Lib "TLIST32P.OCX" (ByVal TreeBuffer As Long)
        Declare Function TListIsValidBuffer Lib "TLIST32P.OCX" (ByVal TreeBuffer As Long) As Integer
        Declare Function TListSaveBuffer Lib "TLIST32P.OCX" (ByVal TreeBuffer As Long, ByVal nFile As Integer) As Integer
        Declare Function TListLoadBuffer Lib "TLIST32P.OCX" (TreeBuffer As Long, ByVal nFile As Integer) As Integer
        Declare Function TListCopyBuffer Lib "TLIST32P.OCX" (ByVal TreeBuffer As Long) As Integer
        Declare Function TListPasteBuffer Lib "TLIST32P.OCX" (TreeBuffer As Long) As Integer
        Declare Function TListIsClipboardFormatAvailable Lib "TLIST32P.OCX" () As Integer
#End If

'================================================================================
' TList functions declarations: These functions are defined for compatibility with 
'       the VBX edition.    Basically they are translations from the OCX Methods to the
'	Functional representations.	

Public Function TListTranslateIndex(tltTree As TList, ByVal nFromIndexMethod As Integer, ByVal nToIndexMethod As Integer, ByVal nFromIndex As Integer) As Integer
    TListTranslateIndex = tltTree.TranslateIndex(nFromIndexMethod, nToIndexMethod, nFromIndex)
End Function

Public Function TListFindItem(tltTree As TList, ByVal FindWhat As String, ByVal nFlags%, ByVal nFromIndex%, ByVal nToIndex%) As Integer
  TListFindItem = tltTree.FindItem(FindWhat, nFlags%, nFromIndex%, nToIndex%)
End Function

Public Function TListFindValue(tltTree As TList, FindWhat As Variant, ByVal nFlags%, ByVal nFromIndex%, ByVal nToIndex%) As Integer
  TListFindValue = tltTree.FindValue(FindWhat, nFlags%, nFromIndex%, nToIndex%)
End Function

Public Function TListIndexByBM(tltTree As TList, ByVal hTreeBookmark&) As Integer
  TListIndexByBM = tltTree.IndexByBM(hTreeBookmark&)
End Function

Public Function TListIsValidBM(tltTree As TList, ByVal hTreeBookmark&) As Boolean
  TListIsValidBM = tltTree.IsValidBM(hTreeBookmark&)
End Function

Public Function TListGetItemByXY(tltTree As TList, ByVal nX As Integer, ByVal nY As Integer, ByVal nType As Integer) As Integer
  TListGetItemByXY = tltTree.GetItemByXY(nX, nY, nType)
End Function

Public Function TListGetItemRect(tltTree As TList, ByVal nIndex As Integer, ByVal nOpts As Integer, pRect As Integer) As Integer
  TListGetItemRect = tltTree.GetItemRect(nIndex, nOpts, pRect)
End Function



