{ ---------------------------------------------------------------------------
  FILE.........: TLO30P.PAS (for file TLIST32P.OCX version 3.99.08 (12-25-96))
  DESCRIPTION..: This file contains TTListPro class. It is wrapper around
                 TListPro Ole Control.
  NOTE:
                 TList property File changed to FileDP;
                 TList method BeforeDrag changed to BeforeDragDP;
                 TList method OnDragDrop changed to OnDragDropDP;
                 TList method OnDragOver changed to OnDragOverDP;
-----------------------------------------------------------------------------}
unit TLO30P;

interface

uses Ole2, OleCtl, Classes, Graphics, OleCtrls;

type TLRect =
         record
           left   : SmallInt;
           top    : SmallInt;
           right  : SmallInt;
           bottom : SmallInt;
         end;

type

  TTListProHScroll = procedure(Sender: TObject; var CancelDefault, ScrollCode, Pos: Smallint) of object;
  TTListProVScroll = procedure(Sender: TObject; var CancelDefault, ScrollCode, Pos: Smallint) of object;
  TTListProAfterEditing = procedure(Sender: TObject; ItemIndex: Integer; var EditedText: string; CancelledBy: Smallint) of object;
  TTListProEditingKeyDown = procedure(Sender: TObject; ItemIndex: Integer; var KeyCode, Shift: Smallint) of object;
  TTListProEditingKeyPress = procedure(Sender: TObject; ItemIndex: Integer; var KeyAscii: Smallint) of object;
  TTListProEditingKeyUp = procedure(Sender: TObject; ItemIndex: Integer; var KeyCode, Shift: Smallint) of object;
  TTListProCollapse = procedure(Sender: TObject; I: Integer) of object;
  TTListProExpand = procedure(Sender: TObject; I: Integer) of object;
  TTListProMarkClick = procedure(Sender: TObject; I: Integer) of object;
  TTListProMarkDblClick = procedure(Sender: TObject; I: Integer) of object;
  TTListProPlusMinusClick = procedure(Sender: TObject; I: Integer) of object;
  TTListProPlusMinusDblClick = procedure(Sender: TObject; I: Integer) of object;
  TTListProRequestEditing = procedure(Sender: TObject; var Cancel: Smallint; ItemIndex: Integer; var TextToEdit: string; var Options: Smallint) of object;

  TTListPro = class(TOleControl)
  private
    FOnPictureClick: TNotifyEvent;
    FOnPictureDblClick: TNotifyEvent;
    FOnClick: TNotifyEvent;
    FOnDblClick: TNotifyEvent;
    FOnHScroll: TTListProHScroll;
    FOnVScroll: TTListProVScroll;
    FOnAfterEditing: TTListProAfterEditing;
    FOnEditingKeyDown: TTListProEditingKeyDown;
    FOnEditingKeyPress: TTListProEditingKeyPress;
    FOnEditingKeyUp: TTListProEditingKeyUp;
    FOnCollapse: TTListProCollapse;
    FOnExpand: TTListProExpand;
    FOnMarkClick: TTListProMarkClick;
    FOnMarkDblClick: TTListProMarkDblClick;
    FOnPlusMinusClick: TTListProPlusMinusClick;
    FOnPlusMinusDblClick: TTListProPlusMinusDblClick;
    FOnRequestEditing: TTListProRequestEditing;
    function Get_Add(Index: Integer): Integer; stdcall;
    procedure Set_Add(Index: Integer; Value: Integer); stdcall;
    function Get_Clipboard(Index: Integer): Smallint; stdcall;
    procedure Set_Clipboard(Index: Integer; Value: Smallint); stdcall;
    function Get_CoerceIndex(Index: Smallint): Integer; stdcall;
    procedure Set_CoerceIndex(Index: Smallint; Value: Integer); stdcall;
    function Get_CopyItem(Index: Integer): Integer; stdcall;
    procedure Set_CopyItem(Index: Integer; Value: Integer); stdcall;
    function Get_CopyItemSub(Index: Integer): Integer; stdcall;
    procedure Set_CopyItemSub(Index: Integer; Value: Integer); stdcall;
    function Get_CopyOne(Index: Integer): Integer; stdcall;
    procedure Set_CopyOne(Index: Integer; Value: Integer); stdcall;
    function Get_Expand(Index: Integer): TOleBool; stdcall;
    procedure Set_Expand(Index: Integer; Value: TOleBool); stdcall;
    function Get_ExpandEx(Index: Integer): TOleBool; stdcall;
    procedure Set_ExpandEx(Index: Integer; Value: TOleBool); stdcall;
    function Get_HasSubItems(Index: Integer): TOleBool; stdcall;
    procedure Set_HasSubItems(Index: Integer; Value: TOleBool); stdcall;
    function Get_Image(Index: Integer): Variant; stdcall;
    procedure Set_Image(Index: Integer; Value: Variant); stdcall;
    function Get_InvImage(Index: Integer): Variant; stdcall;
    procedure Set_InvImage(Index: Integer; Value: Variant); stdcall;
    function Get_ItemPicValue(Index: Integer): Variant; stdcall;
    procedure Set_ItemPicValue(Index: Integer; Value: Variant); stdcall;
    function Get_MarkPicture(Index: Integer): Variant; stdcall;
    procedure Set_MarkPicture(Index: Integer; Value: Variant); stdcall;
    function Get_TitlePicture(Index: Integer): Variant; stdcall;
    procedure Set_TitlePicture(Index: Integer; Value: Variant); stdcall;
    function Get_Indent(Index: Integer): Smallint; stdcall;
    procedure Set_Indent(Index: Integer; Value: Smallint); stdcall;
    function Get_Insert(Index: Integer): Integer; stdcall;
    procedure Set_Insert(Index: Integer; Value: Integer); stdcall;
    function Get_InsertItem(Index: Integer): string; stdcall;
    procedure Set_InsertItem(Index: Integer; const Value: string); stdcall;
    function Get_IsItemVisible(Index: Integer): TOleBool; stdcall;
    procedure Set_IsItemVisible(Index: Integer; Value: TOleBool); stdcall;
    function Get_ItemBM(Index: Integer): Integer; stdcall;
    procedure Set_ItemBM(Index: Integer; Value: Integer); stdcall;
    function Get_ItemBackColor(Index: Integer): Integer; stdcall;
    procedure Set_ItemBackColor(Index: Integer; Value: Integer); stdcall;
    function Get_ItemEditText(Index: Integer): Smallint; stdcall;
    procedure Set_ItemEditText(Index: Integer; Value: Smallint); stdcall;
    function Get_ItemFontBold(Index: Integer): TOleBool; stdcall;
    procedure Set_ItemFontBold(Index: Integer; Value: TOleBool); stdcall;
    function Get_ItemFontItalic(Index: Integer): TOleBool; stdcall;
    procedure Set_ItemFontItalic(Index: Integer; Value: TOleBool); stdcall;
    function Get_ItemFontName(Index: Integer): string; stdcall;
    procedure Set_ItemFontName(Index: Integer; const Value: string); stdcall;
    function Get_ItemFontSize(Index: Integer): Smallint; stdcall;
    procedure Set_ItemFontSize(Index: Integer; Value: Smallint); stdcall;
    function Get_ItemFontStrike(Index: Integer): TOleBool; stdcall;
    procedure Set_ItemFontStrike(Index: Integer; Value: TOleBool); stdcall;
    function Get_ItemFontUnder(Index: Integer): TOleBool; stdcall;
    procedure Set_ItemFontUnder(Index: Integer; Value: TOleBool); stdcall;
    function Get_ItemForeColor(Index: Integer): Integer; stdcall;
    procedure Set_ItemForeColor(Index: Integer; Value: Integer); stdcall;
    function Get_ItemIntValue(Index: Integer): Smallint; stdcall;
    procedure Set_ItemIntValue(Index: Integer; Value: Smallint); stdcall;
    function Get_ItemLngValue(Index: Integer): Integer; stdcall;
    procedure Set_ItemLngValue(Index: Integer; Value: Integer); stdcall;
    function Get_ItemMark(Index: Integer): Integer; stdcall;
    procedure Set_ItemMark(Index: Integer; Value: Integer); stdcall;
    function Get_ItemMultiLine(Index: Integer): Smallint; stdcall;
    procedure Set_ItemMultiLine(Index: Integer; Value: Smallint); stdcall;
    function Get_ItemParentBM(Index: Integer): Integer; stdcall;
    procedure Set_ItemParentBM(Index: Integer; Value: Integer); stdcall;
    function Get_ItemSngValue(Index: Integer): Single; stdcall;
    procedure Set_ItemSngValue(Index: Integer; Value: Single); stdcall;
    function Get_ItemSorted(Index: Integer): Smallint; stdcall;
    procedure Set_ItemSorted(Index: Integer; Value: Smallint); stdcall;
    function Get_ItemStrValue(Index: Integer): string; stdcall;
    procedure Set_ItemStrValue(Index: Integer; const Value: string); stdcall;
    function Get_ItemType(Index: Integer): Smallint; stdcall;
    procedure Set_ItemType(Index: Integer; Value: Smallint); stdcall;
    function Get_List(Index: Integer): string; stdcall;
    procedure Set_List(Index: Integer; const Value: string); stdcall;
    function Get_ListCountEx(Index: Integer): Integer; stdcall;
    procedure Set_ListCountEx(Index: Integer; Value: Integer); stdcall;
    function Get_LoadAndAdd(Index: Integer): Smallint; stdcall;
    procedure Set_LoadAndAdd(Index: Integer; Value: Smallint); stdcall;
    function Get_LoadAndInsert(Index: Integer): Smallint; stdcall;
    procedure Set_LoadAndInsert(Index: Integer; Value: Smallint); stdcall;
    function Get_MarkTag(Index: Integer): string; stdcall;
    procedure Set_MarkTag(Index: Integer; const Value: string); stdcall;
    function Get_Save(Index: Integer): Smallint; stdcall;
    procedure Set_Save(Index: Integer; Value: Smallint); stdcall;
    function Get_SaveOne(Index: Integer): Smallint; stdcall;
    procedure Set_SaveOne(Index: Integer; Value: Smallint); stdcall;
    function Get_SaveSub(Index: Integer): Smallint; stdcall;
    procedure Set_SaveSub(Index: Integer; Value: Smallint); stdcall;
    function Get_SelItemIndex(Index: Integer): Integer; stdcall;
    procedure Set_SelItemIndex(Index: Integer; Value: Integer); stdcall;
    function Get_SelectEx(Index: Integer): TOleBool; stdcall;
    procedure Set_SelectEx(Index: Integer; Value: TOleBool); stdcall;
    function Get_Selected(Index: Integer): TOleBool; stdcall;
    procedure Set_Selected(Index: Integer; Value: TOleBool); stdcall;
    function Get_Shift(Index: Integer): Smallint; stdcall;
    procedure Set_Shift(Index: Integer; Value: Smallint); stdcall;
    function Get_TitleText(Index: Integer): string; stdcall;
    procedure Set_TitleText(Index: Integer; const Value: string); stdcall;
    function Get_TitleVisible(Index: Integer): TOleBool; stdcall;
    procedure Set_TitleVisible(Index: Integer; Value: TOleBool); stdcall;
    function Get_TitleWidth(Index: Integer): Single; stdcall;
    procedure Set_TitleWidth(Index: Integer; Value: Single); stdcall;
    function Get_FullPath(Index: Integer): string; stdcall;
    procedure Set_FullPath(Index: Integer; const Value: string); stdcall;
    function Get_FileDP(FileIndex: Smallint): Smallint; stdcall;
    procedure Set_FileDP(FileIndex: Smallint; Value: Smallint); stdcall;
    function Get_ItemPMPicType(Index: Integer): Smallint; stdcall;
    procedure Set_ItemPMPicType(Index: Integer; Value: Smallint); stdcall;
  protected
    procedure InitControlData; override;
  public
    procedure Refresh; stdcall;
    procedure AddItem(const ItemText: string; Index: Variant); stdcall;
    function IsValidBM(hTreeBookmark: Integer): TOleBool; stdcall;
    procedure OnDragOverDP(X, Y: Single; State: Smallint); stdcall;
    procedure OnDragDropDP(X, Y: Single); stdcall;
    procedure BeforeDragDP; stdcall;
    procedure Clear; stdcall;
    function FindItem(const FindWhat: string; nFlags: Smallint; nFromIndex, nToIndex: Integer): Integer; stdcall;
    function FindValue(FindWhat: Variant; nFlags: Smallint; nFromIndex, nToIndex: Integer): Integer; stdcall;
    function GetItemByXY(nX, nY, nType: Smallint): Integer; stdcall;
    function GetItemRect(Index: Integer; nOpts: Smallint; var pRect: TLRect): Smallint; stdcall;
    function IndexByBM(hTreeBookmark: Integer): Integer; stdcall;
    procedure RemoveItem(Index: Integer); stdcall;
    function TranslateIndex(nFromIndexMethod, nToIndexMethod: Smallint; nFromIndex: Integer): Integer; stdcall;
    function DropTarget: Integer; stdcall;
    function FastAddItem(Shift: Smallint; const Text: string; Options: Integer): Smallint; stdcall;
    function FastAddItemEx(Shift: Smallint; const Text: string; Options: Integer; const FontName: string; FontSize: Smallint; BackColor, ForeColor: Integer): Smallint; stdcall;
    procedure FreeBuffer(TreeBuffer: Integer); stdcall;
    function IsValidBuffer(TreeBuffer: Integer): Smallint; stdcall;
    function SaveBuffer(TreeBuffer: Integer; nFile: Smallint): Smallint; stdcall;
    function LoadBuffer(var TreeBuffer: Integer; nFile: Smallint): Smallint; stdcall;
    function CopyBuffer(TreeBuffer: Integer): Smallint; stdcall;
    function PasteBuffer(var TreeBuffer: Integer): Smallint; stdcall;
    function IsClipboardFormatAvailable: Smallint; stdcall;
    procedure AboutBox; stdcall;
    property Add[Index: Integer]: Integer read Get_Add write Set_Add;
    property Clipboard[Index: Integer]: Smallint read Get_Clipboard write Set_Clipboard;
    property CoerceIndex[Index: Smallint]: Integer read Get_CoerceIndex write Set_CoerceIndex;
    property CopyItem[Index: Integer]: Integer read Get_CopyItem write Set_CopyItem;
    property CopyItemSub[Index: Integer]: Integer read Get_CopyItemSub write Set_CopyItemSub;
    property CopyOne[Index: Integer]: Integer read Get_CopyOne write Set_CopyOne;
    property Expand[Index: Integer]: TOleBool read Get_Expand write Set_Expand;
    property ExpandEx[Index: Integer]: TOleBool read Get_ExpandEx write Set_ExpandEx;
    property HasSubItems[Index: Integer]: TOleBool read Get_HasSubItems write Set_HasSubItems;
    property Image[Index: Integer]: Variant read Get_Image write Set_Image;
    property InvImage[Index: Integer]: Variant read Get_InvImage write Set_InvImage;
    property ItemPicValue[Index: Integer]: Variant read Get_ItemPicValue write Set_ItemPicValue;
    property MarkPicture[Index: Integer]: Variant read Get_MarkPicture write Set_MarkPicture;
    property TitlePicture[Index: Integer]: Variant read Get_TitlePicture write Set_TitlePicture;
    property Indent[Index: Integer]: Smallint read Get_Indent write Set_Indent;
    property Insert[Index: Integer]: Integer read Get_Insert write Set_Insert;
    property InsertItem[Index: Integer]: string read Get_InsertItem write Set_InsertItem;
    property IsItemVisible[Index: Integer]: TOleBool read Get_IsItemVisible write Set_IsItemVisible;
    property ItemBM[Index: Integer]: Integer read Get_ItemBM write Set_ItemBM;
    property ItemBackColor[Index: Integer]: Integer read Get_ItemBackColor write Set_ItemBackColor;
    property ItemEditText[Index: Integer]: Smallint read Get_ItemEditText write Set_ItemEditText;
    property ItemFontBold[Index: Integer]: TOleBool read Get_ItemFontBold write Set_ItemFontBold;
    property ItemFontItalic[Index: Integer]: TOleBool read Get_ItemFontItalic write Set_ItemFontItalic;
    property ItemFontName[Index: Integer]: string read Get_ItemFontName write Set_ItemFontName;
    property ItemFontSize[Index: Integer]: Smallint read Get_ItemFontSize write Set_ItemFontSize;
    property ItemFontStrike[Index: Integer]: TOleBool read Get_ItemFontStrike write Set_ItemFontStrike;
    property ItemFontUnder[Index: Integer]: TOleBool read Get_ItemFontUnder write Set_ItemFontUnder;
    property ItemForeColor[Index: Integer]: Integer read Get_ItemForeColor write Set_ItemForeColor;
    property ItemIntValue[Index: Integer]: Smallint read Get_ItemIntValue write Set_ItemIntValue;
    property ItemLngValue[Index: Integer]: Integer read Get_ItemLngValue write Set_ItemLngValue;
    property ItemMark[Index: Integer]: Integer read Get_ItemMark write Set_ItemMark;
    property ItemMultiLine[Index: Integer]: Smallint read Get_ItemMultiLine write Set_ItemMultiLine;
    property ItemParentBM[Index: Integer]: Integer read Get_ItemParentBM write Set_ItemParentBM;
    property ItemSngValue[Index: Integer]: Single read Get_ItemSngValue write Set_ItemSngValue;
    property ItemSorted[Index: Integer]: Smallint read Get_ItemSorted write Set_ItemSorted;
    property ItemStrValue[Index: Integer]: string read Get_ItemStrValue write Set_ItemStrValue;
    property ItemType[Index: Integer]: Smallint read Get_ItemType write Set_ItemType;
    property List[Index: Integer]: string read Get_List write Set_List;
    property ListCountEx[Index: Integer]: Integer read Get_ListCountEx write Set_ListCountEx;
    property LoadAndAdd[Index: Integer]: Smallint read Get_LoadAndAdd write Set_LoadAndAdd;
    property LoadAndInsert[Index: Integer]: Smallint read Get_LoadAndInsert write Set_LoadAndInsert;
    property MarkTag[Index: Integer]: string read Get_MarkTag write Set_MarkTag;
    property Save[Index: Integer]: Smallint read Get_Save write Set_Save;
    property SaveOne[Index: Integer]: Smallint read Get_SaveOne write Set_SaveOne;
    property SaveSub[Index: Integer]: Smallint read Get_SaveSub write Set_SaveSub;
    property SelItemIndex[Index: Integer]: Integer read Get_SelItemIndex write Set_SelItemIndex;
    property SelectEx[Index: Integer]: TOleBool read Get_SelectEx write Set_SelectEx;
    property Selected[Index: Integer]: TOleBool read Get_Selected write Set_Selected;
    property Shift[Index: Integer]: Smallint read Get_Shift write Set_Shift;
    property TitleText[Index: Integer]: string read Get_TitleText write Set_TitleText;
    property TitleVisible[Index: Integer]: TOleBool read Get_TitleVisible write Set_TitleVisible;
    property TitleWidth[Index: Integer]: Single read Get_TitleWidth write Set_TitleWidth;
    property FullPath[Index: Integer]: string read Get_FullPath write Set_FullPath;
    property FileDP[FileIndex: Smallint]: Smallint read Get_FileDP write Set_FileDP;
    property ItemPMPicType[Index: Integer]: Smallint read Get_ItemPMPicType write Set_ItemPMPicType;
  published
    property ParentFont;
    property TabStop;
    property DragCursor;
    property DragMode;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property Visible;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnStartDrag;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnDragOver;
    property OnDragDrop;
    property MousePointer: TOleEnum index 1 read GetOleEnumProp write SetOleEnumProp stored False;
    property FontBold: TOleBool index 2 read GetOleBoolProp write SetOleBoolProp stored False;
    property FontItalic: TOleBool index 3 read GetOleBoolProp write SetOleBoolProp stored False;
    property FontName: string index 4 read GetStringProp write SetStringProp stored False;
    property FontSize: Single index 5 read GetSingleProp write SetSingleProp stored False;
    property FontStrikethru: TOleBool index 6 read GetOleBoolProp write SetOleBoolProp stored False;
    property FontUnderline: TOleBool index 7 read GetOleBoolProp write SetOleBoolProp stored False;
    property ForeColor: TColor index 8 read GetColorProp write SetColorProp stored False;
    property ImageStretch: TOleBool index 9 read GetOleBoolProp write SetOleBoolProp stored False;
    property InvStyle: TOleEnum index 10 read GetOleEnumProp write SetOleEnumProp stored False;
    property ViewStyle: TOleEnum index 11 read GetOleEnumProp write SetOleEnumProp stored False;
    property Redraw: TOleBool index 12 read GetOleBoolProp write SetOleBoolProp stored False;
    property MultiSelect: TOleEnum index 13 read GetOleEnumProp write SetOleEnumProp stored False;
    property PictureType: TOleEnum index 14 read GetOleEnumProp write SetOleEnumProp stored False;
    property PathSeparator: string index 15 read GetStringProp write SetStringProp stored False;
    property PictureRoot: Variant index 16 read GetVariantProp write SetVariantProp stored False;
    property PictureOpen: Variant index 17 read GetVariantProp write SetVariantProp stored False;
    property CurrentIndexMethod: TOleEnum index 18 read GetOleEnumProp write SetOleEnumProp stored False;
    property SelForeColor: TColor index 19 read GetColorProp write SetColorProp stored False;
    property SelBackColor: TColor index 20 read GetColorProp write SetColorProp stored False;
    property NoIntegralHeight: TOleBool index 21 read GetOleBoolProp write SetOleBoolProp stored False;
    property DisableNoScroll: TOleBool index 22 read GetOleBoolProp write SetOleBoolProp stored False;
    property CurrentItem: string index 23 read GetStringProp write SetStringProp stored False;
    property ShowChildren: TOleBool index 24 read GetOleBoolProp write SetOleBoolProp stored False;
    property FixedSize: TOleBool index 25 read GetOleBoolProp write SetOleBoolProp stored False;
    property TriggerEvents: Integer index 26 read GetIntegerProp write SetIntegerProp stored False;
    property Scrollbars: TOleEnum index 27 read GetOleEnumProp write SetOleEnumProp stored False;
    property ScrollHorz: Smallint index 28 read GetSmallintProp write SetSmallintProp stored False;
    property Text: string index 29 read GetStringProp write SetStringProp stored False;
    property IsClipboardAvailable: TOleBool index 30 read GetOleBoolProp write SetOleBoolProp stored False;
    property PicturePlus: Variant index 31 read GetVariantProp write SetVariantProp stored False;
    property PictureMinus: Variant index 32 read GetVariantProp write SetVariantProp stored False;
    property PictureMark: Variant index 33 read GetVariantProp write SetVariantProp stored False;
    property NoPictureRoot: TOleBool index 34 read GetOleBoolProp write SetOleBoolProp stored False;
    property ViewStyleEx: TOleEnum index 35 read GetOleEnumProp write SetOleEnumProp stored False;
    property AutoExpand: TOleEnum index 36 read GetOleEnumProp write SetOleEnumProp stored False;
    property TreeLinesStyle: TOleEnum index 37 read GetOleEnumProp write SetOleEnumProp stored False;
    property PicInMultiLine: TOleEnum index 38 read GetOleEnumProp write SetOleEnumProp stored False;
    property ShowCaption: TOleEnum index 39 read GetOleEnumProp write SetOleEnumProp stored False;
    property Caption: string index 40 read GetStringProp write SetStringProp stored False;
    property ShowTitles: TOleEnum index 41 read GetOleEnumProp write SetOleEnumProp stored False;
    property MSOutlineAdd: TOleBool index 42 read GetOleBoolProp write SetOleBoolProp stored False;
    property CurrentItemBM: Integer index 43 read GetIntegerProp write SetIntegerProp stored False;
    property BackwardCompatibility: TOleBool index 44 read GetOleBoolProp write SetOleBoolProp stored False;
    property ExpandChildren: TOleBool index 45 read GetOleBoolProp write SetOleBoolProp stored False;
    property ExpandNewItem: TOleBool index 46 read GetOleBoolProp write SetOleBoolProp stored False;
    property BackColor: TColor index 47 read GetColorProp write SetColorProp stored False;
    property AutoScrDuringDragDrop: TOleEnum index 48 read GetOleEnumProp write SetOleEnumProp stored False;
    property DragHighlight: TOleEnum index 49 read GetOleEnumProp write SetOleEnumProp stored False;
    property ShiftStep: Single index 50 read GetSingleProp write SetSingleProp stored False;
    property ItemImageDefHeight: Single index 51 read GetSingleProp write SetSingleProp stored False;
    property ItemImageDefWidth: Single index 52 read GetSingleProp write SetSingleProp stored False;
    property MarkHeight: Single index 53 read GetSingleProp write SetSingleProp stored False;
    property MarkWidth: Single index 54 read GetSingleProp write SetSingleProp stored False;
    property TabStopDistance: Single index 55 read GetSingleProp write SetSingleProp stored False;
    property TitleHeight: Single index 56 read GetSingleProp write SetSingleProp stored False;
    property WidthOfText: Single index 57 read GetSingleProp write SetSingleProp stored False;
    property XOffset: Single index 58 read GetSingleProp write SetSingleProp stored False;
    property DefMultiLine: TOleBool index 59 read GetOleBoolProp write SetOleBoolProp stored False;
    property MouseIcon: Variant index 60 read GetVariantProp write SetVariantProp stored False;
    property BottomIndex: Integer index 61 read GetIntegerProp write SetIntegerProp stored False;
    property ClearItem: Integer index 62 read GetIntegerProp write SetIntegerProp stored False;
    property CopySelected: Integer index 63 read GetIntegerProp write SetIntegerProp stored False;
    property PictureClosed: Variant index 64 read GetVariantProp write SetVariantProp stored False;
    property PictureInverted: Variant index 65 read GetVariantProp write SetVariantProp stored False;
    property PictureLeaf: Variant index 66 read GetVariantProp write SetVariantProp stored False;
    property ListCount: Integer index 67 read GetIntegerProp write SetIntegerProp stored False;
    property ListIndex: Integer index 68 read GetIntegerProp write SetIntegerProp stored False;
    property NewIndex: Integer index 69 read GetIntegerProp write SetIntegerProp stored False;
    property TopIndex: Integer index 70 read GetIntegerProp write SetIntegerProp stored False;
    property SelItemCount: Integer index 71 read GetIntegerProp write SetIntegerProp stored False;
    property WidthOfTextMin: Single index 72 read GetSingleProp write SetSingleProp stored False;
    property SmartDragDrop: TOleBool index 73 read GetOleBoolProp write SetOleBoolProp stored False;
    property Font: Variant index -512 read GetVariantProp write SetVariantProp stored False;
    property BorderStyle: TOleEnum index -504 read GetOleEnumProp write SetOleEnumProp stored False;
    property Enabled: TOleBool index -514 read GetOleBoolProp write SetOleBoolProp stored False;
    property hWnd: Integer index -515 read GetIntegerProp write SetIntegerProp stored False;
    property Environment: TOleEnum index 145 read GetOleEnumProp write SetOleEnumProp stored False;
    property TreeLinesColor: TColor index 153 read GetColorProp write SetColorProp stored False;
    property DrawFocusRect: TOleBool index 154 read GetOleBoolProp write SetOleBoolProp stored False;
    property LcPresent: TOleBool index 155 read GetOleBoolProp write SetOleBoolProp stored False;
    property ExplorerCompatible: TOleEnum index 156 read GetOleEnumProp write SetOleEnumProp stored False;
    property ToolTipsMode: TOleEnum index 157 read GetOleEnumProp write SetOleEnumProp stored False;
    property ToolTipsViewStyle: TOleEnum index 158 read GetOleEnumProp write SetOleEnumProp stored False;
    property ToolTipsForeColor: TColor index 159 read GetColorProp write SetColorProp stored False;
    property ToolTipsBackColor: TColor index 160 read GetColorProp write SetColorProp stored False;
    property OnPictureClick: TNotifyEvent read FOnPictureClick write FOnPictureClick;
    property OnPictureDblClick: TNotifyEvent read FOnPictureDblClick write FOnPictureDblClick;
    property OnClick: TNotifyEvent read FOnClick write FOnClick;
    property OnDblClick: TNotifyEvent read FOnDblClick write FOnDblClick;
    property OnHScroll: TTListProHScroll read FOnHScroll write FOnHScroll;
    property OnVScroll: TTListProVScroll read FOnVScroll write FOnVScroll;
    property OnAfterEditing: TTListProAfterEditing read FOnAfterEditing write FOnAfterEditing;
    property OnEditingKeyDown: TTListProEditingKeyDown read FOnEditingKeyDown write FOnEditingKeyDown;
    property OnEditingKeyPress: TTListProEditingKeyPress read FOnEditingKeyPress write FOnEditingKeyPress;
    property OnEditingKeyUp: TTListProEditingKeyUp read FOnEditingKeyUp write FOnEditingKeyUp;
    property OnCollapse: TTListProCollapse read FOnCollapse write FOnCollapse;
    property OnExpand: TTListProExpand read FOnExpand write FOnExpand;
    property OnMarkClick: TTListProMarkClick read FOnMarkClick write FOnMarkClick;
    property OnMarkDblClick: TTListProMarkDblClick read FOnMarkDblClick write FOnMarkDblClick;
    property OnPlusMinusClick: TTListProPlusMinusClick read FOnPlusMinusClick write FOnPlusMinusClick;
    property OnPlusMinusDblClick: TTListProPlusMinusDblClick read FOnPlusMinusDblClick write FOnPlusMinusDblClick;
    property OnRequestEditing: TTListProRequestEditing read FOnRequestEditing write FOnRequestEditing;
  end;

Const
{ ItemType property constants}
  TLTYPE_NONE = $0;
  TLTYPE_INT  = $494E;
  TLTYPE_LNG  = $4C4E;
  TLTYPE_SNG  = $534E;
  TLTYPE_STR  = $5354;
  TLTYPE_PIC  = $5450;

{ TListGetItemByXY function nType parameter constants}
  PTFIND_ITEM = 1;
  PTFIND_PIC  = 2;

{ TListGetItemRect function nType parameter constants}
  TLGR_ITEM      = $1;
  TLGR_PLUSMINUS = $2;
  TLGR_MARK      = $4;
  TLGR_PICTURE   = $8;
  TLGR_TEXT      = $10;

{ Error codes constants}
  TLERR_BADINDENTATION    = 20101;
  TLERR_WRONPARAMS        = 20102; { Obselete }
  TLERR_ITEMNOTFOUND      = 20103;
  TLERR_PARENTNOTEXPANDED = 20104;
  TLERR_INITFAULT         = 20105;
  TLERR_CANNOTSHOW        = 20106;
  TLERR_INVALIDSEPARATOR  = 20107;
  TLERR_INVALIDTREEBUFFER = 20108;
  TLERR_BIGPICSIZE        = 20109;
  TLERR_NOTHINGTOCOPY     = 20110;
  TLERR_TOMANYITEMS       = 20111;
  TLERR_TOMANYSUBITEMS    = 20112;
  TLERR_INVALIDARGS       = 20113;

{ TriggerEvents property constants}
  TL_TRIGGER_INITIAL          = 0;
  TL_TRIGGER_COLLAPSE_FOR_ALL = 1;

{ ItemEditText property  constants}
  TL_EDITTEXT_CANCEL = $0;
  TL_EDITTEXT_END    = $1;
  TL_EDITTEXT_BEGIN  = $2;

{ Clipboard property  constants}
  TL_CLP_COPY           = 0;
  TL_CLP_COPYONE        = 1;
  TL_CLP_COPYSUB        = 2;
  TL_CLP_PASTEANDADD    = 3;
  TL_CLP_PASTEANDINSERT = 4;

{ VScroll & HScroll ScrollCode parameter constants}
  TL_SB_LINEUP        = 0;
  TL_SB_LINEDOWN      = 1;
  TL_SB_PAGEUP        = 2;
  TL_SB_PAGEDOWN      = 3;
  TL_SB_THUMBPOSITION = 4;
  TL_SB_THUMBTRACK    = 5;
  TL_SB_TOP           = 6;
  TL_SB_BOTTOM        = 7;
  TL_SB_ENDSCROLL     = 8;

{ AfterEditing Options parameter constants}
  TL_EDCANCELLEDBY_USER     = $0;
  TL_EDCANCELLEDBY_PROPERTY = $1;

{ RequestEditing Options parameter constants}
  TL_REQED_LEFT        = $0;
  TL_REQED_CENTER      = $1;
  TL_REQED_RIGHT       = $2;
  TL_REQED_MULTILINE   = $4;
  TL_REQED_UPPERCASE   = $8;
  TL_REQED_LOWERCASE   = $10;
  TL_REQED_PASSWORD    = $20;
  TL_REQED_AUTOVSCROLL = $40;
  TL_REQED_AUTOHSCROLL = $80;
  TL_REQED_STDCOLORS   = $100;
  TL_REQED_BORDER      = $200;
  TL_REQED_VSCROLLER   = $400;
  TL_REQED_READONLY    = $800;
  TL_REQED_HSCROLLER   = $2000;

{ TListFindItem function nFlags parameter constants}
  TL_FI_DONTUSECASE = $1;
  TL_FI_RELAXED     = $2;
  TL_FI_BACKDIR     = $100;
  TL_FI_SELONLY     = $200;


procedure Register;

implementation

{$J+}

procedure TTListPro.InitControlData;
const
  CEventDispIDs: array[0..16] of Integer = (
    $00000001, $00000002, $00000003, $00000004, $00000005, $00000006,
    $00000007, $00000008, $00000009, $0000000A, $0000000B, $0000000C,
    $0000000D, $0000000E, $0000000F, $00000010, $00000011);
  CLicenseKey: array[0..57] of Word = (
    $0043, $006F, $0070, $0079, $0072, $0069, $0067, $0068, $0074, $0020,
    $0028, $0063, $0029, $0020, $0031, $0039, $0039, $0035, $0020, $0042,
    $0065, $006E, $006E, $0065, $0074, $002D, $0054, $0065, $0063, $002E,
    $0020, $0054, $004C, $0069, $0073, $0074, $0020, $004F, $0043, $0058,
    $0020, $0033, $002E, $0030, $0020, $0033, $0032, $002D, $0062, $0069,
    $0074, $0028, $0050, $0072, $006F, $0029, $002E, $0000);
  CControlData: TControlData = (
    ClassID: (
      D1:$9D998170;D2:$B884;D3:$11CE;D4:($8D,$47,$44,$45,$53,$54,$00,$00));
    EventIID: (
      D1:$9D998172;D2:$B884;D3:$11CE;D4:($8D,$47,$44,$45,$53,$54,$00,$00));
    EventCount: 17;
    EventDispIDs: @CEventDispIDs;
    LicenseKey: @CLicenseKey;
    Flags: $0000000C);
begin
  ControlData := @CControlData;
end;

procedure TTListPro.Refresh;
const
  DispInfo: array[0..7] of Byte = ($DA,$FD,$FF,$FF,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TTListPro.AddItem;
const
  DispInfo: array[0..9] of Byte = ($4A,$00,$00,$00,$00,$01,$02,$00,$08,$0C);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.IsValidBM;
const
  DispInfo: array[0..8] of Byte = ($4B,$00,$00,$00,$0B,$01,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.OnDragOverDP;
const
  DispInfo: array[0..10] of Byte = ($4C,$00,$00,$00,$00,$01,$03,$00,$04,$04,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TTListPro.OnDragDropDP;
const
  DispInfo: array[0..9] of Byte = ($4D,$00,$00,$00,$00,$01,$02,$00,$04,$04);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TTListPro.BeforeDragDP;
const
  DispInfo: array[0..7] of Byte = ($4E,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TTListPro.Clear;
const
  DispInfo: array[0..7] of Byte = ($4F,$00,$00,$00,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.FindItem;
const
  DispInfo: array[0..11] of Byte = ($50,$00,$00,$00,$03,$01,$04,$00,$08,$02,$03,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TTListPro.FindValue;
const
  DispInfo: array[0..11] of Byte = ($51,$00,$00,$00,$03,$01,$04,$00,$0C,$02,$03,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TTListPro.GetItemByXY;
const
  DispInfo: array[0..10] of Byte = ($52,$00,$00,$00,$03,$01,$03,$00,$02,$02,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TTListPro.GetItemRect;
const
  DispInfo: array[0..10] of Byte = ($53,$00,$00,$00,$02,$01,$03,$00,$03,$02,$82);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TTListPro.IndexByBM;
const
  DispInfo: array[0..8] of Byte = ($54,$00,$00,$00,$03,$01,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.RemoveItem;
const
  DispInfo: array[0..8] of Byte = ($55,$00,$00,$00,$00,$01,$01,$00,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.TranslateIndex;
const
  DispInfo: array[0..10] of Byte = ($56,$00,$00,$00,$03,$01,$03,$00,$02,$02,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TTListPro.DropTarget;
const
  DispInfo: array[0..7] of Byte = ($57,$00,$00,$00,$03,$01,$00,$00);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TTListPro.FastAddItem;
const
  DispInfo: array[0..10] of Byte = ($58,$00,$00,$00,$02,$01,$03,$00,$02,$08,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TTListPro.FastAddItemEx;
const
  DispInfo: array[0..14] of Byte = ($59,$00,$00,$00,$02,$01,$07,$00,$02,$08,$03,$08,$02,$03,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.FreeBuffer;
const
  DispInfo: array[0..8] of Byte = ($92,$00,$00,$00,$00,$01,$01,$00,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.IsValidBuffer;
const
  DispInfo: array[0..8] of Byte = ($93,$00,$00,$00,$02,$01,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TTListPro.SaveBuffer;
const
  DispInfo: array[0..9] of Byte = ($94,$00,$00,$00,$02,$01,$02,$00,$03,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TTListPro.LoadBuffer;
const
  DispInfo: array[0..9] of Byte = ($95,$00,$00,$00,$02,$01,$02,$00,$83,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TTListPro.CopyBuffer;
const
  DispInfo: array[0..8] of Byte = ($96,$00,$00,$00,$02,$01,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TTListPro.PasteBuffer;
const
  DispInfo: array[0..8] of Byte = ($97,$00,$00,$00,$02,$01,$01,$00,$83);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TTListPro.IsClipboardFormatAvailable;
const
  DispInfo: array[0..7] of Byte = ($98,$00,$00,$00,$02,$01,$00,$00);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.AboutBox;
const
  DispInfo: array[0..7] of Byte = ($D8,$FD,$FF,$FF,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_Add;
const
  DispInfo: array[0..8] of Byte = ($5A,$00,$00,$00,$03,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_Add;
const
  DispInfo: array[0..9] of Byte = ($5A,$00,$00,$00,$00,$04,$02,$00,$03,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_Clipboard;
const
  DispInfo: array[0..8] of Byte = ($5B,$00,$00,$00,$02,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_Clipboard;
const
  DispInfo: array[0..9] of Byte = ($5B,$00,$00,$00,$00,$04,$02,$00,$03,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_CoerceIndex;
const
  DispInfo: array[0..8] of Byte = ($5C,$00,$00,$00,$03,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_CoerceIndex;
const
  DispInfo: array[0..9] of Byte = ($5C,$00,$00,$00,$00,$04,$02,$00,$02,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_CopyItem;
const
  DispInfo: array[0..8] of Byte = ($5D,$00,$00,$00,$03,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_CopyItem;
const
  DispInfo: array[0..9] of Byte = ($5D,$00,$00,$00,$00,$04,$02,$00,$03,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_CopyItemSub;
const
  DispInfo: array[0..8] of Byte = ($5E,$00,$00,$00,$03,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_CopyItemSub;
const
  DispInfo: array[0..9] of Byte = ($5E,$00,$00,$00,$00,$04,$02,$00,$03,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_CopyOne;
const
  DispInfo: array[0..8] of Byte = ($5F,$00,$00,$00,$03,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_CopyOne;
const
  DispInfo: array[0..9] of Byte = ($5F,$00,$00,$00,$00,$04,$02,$00,$03,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_Expand;
const
  DispInfo: array[0..8] of Byte = ($60,$00,$00,$00,$0B,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_Expand;
const
  DispInfo: array[0..9] of Byte = ($60,$00,$00,$00,$00,$04,$02,$00,$03,$0B);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_ExpandEx;
const
  DispInfo: array[0..8] of Byte = ($61,$00,$00,$00,$0B,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_ExpandEx;
const
  DispInfo: array[0..9] of Byte = ($61,$00,$00,$00,$00,$04,$02,$00,$03,$0B);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_HasSubItems;
const
  DispInfo: array[0..8] of Byte = ($62,$00,$00,$00,$0B,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_HasSubItems;
const
  DispInfo: array[0..9] of Byte = ($62,$00,$00,$00,$00,$04,$02,$00,$03,$0B);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_Image;
const
  DispInfo: array[0..8] of Byte = ($63,$00,$00,$00,$0C,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_Image;
const
  DispInfo: array[0..9] of Byte = ($63,$00,$00,$00,$00,$04,$02,$00,$03,$0C);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_InvImage;
const
  DispInfo: array[0..8] of Byte = ($64,$00,$00,$00,$0C,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_InvImage;
const
  DispInfo: array[0..9] of Byte = ($64,$00,$00,$00,$00,$04,$02,$00,$03,$0C);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_ItemPicValue;
const
  DispInfo: array[0..8] of Byte = ($65,$00,$00,$00,$0C,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_ItemPicValue;
const
  DispInfo: array[0..9] of Byte = ($65,$00,$00,$00,$00,$04,$02,$00,$03,$0C);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_MarkPicture;
const
  DispInfo: array[0..8] of Byte = ($66,$00,$00,$00,$0C,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_MarkPicture;
const
  DispInfo: array[0..9] of Byte = ($66,$00,$00,$00,$00,$04,$02,$00,$03,$0C);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_TitlePicture;
const
  DispInfo: array[0..8] of Byte = ($67,$00,$00,$00,$0C,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_TitlePicture;
const
  DispInfo: array[0..9] of Byte = ($67,$00,$00,$00,$00,$04,$02,$00,$03,$0C);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_Indent;
const
  DispInfo: array[0..8] of Byte = ($68,$00,$00,$00,$02,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_Indent;
const
  DispInfo: array[0..9] of Byte = ($68,$00,$00,$00,$00,$04,$02,$00,$03,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_Insert;
const
  DispInfo: array[0..8] of Byte = ($69,$00,$00,$00,$03,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_Insert;
const
  DispInfo: array[0..9] of Byte = ($69,$00,$00,$00,$00,$04,$02,$00,$03,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_InsertItem;
const
  DispInfo: array[0..8] of Byte = ($6A,$00,$00,$00,$08,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_InsertItem;
const
  DispInfo: array[0..9] of Byte = ($6A,$00,$00,$00,$00,$04,$02,$00,$03,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_IsItemVisible;
const
  DispInfo: array[0..8] of Byte = ($6B,$00,$00,$00,$0B,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_IsItemVisible;
const
  DispInfo: array[0..9] of Byte = ($6B,$00,$00,$00,$00,$04,$02,$00,$03,$0B);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_ItemBM;
const
  DispInfo: array[0..8] of Byte = ($6C,$00,$00,$00,$03,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_ItemBM;
const
  DispInfo: array[0..9] of Byte = ($6C,$00,$00,$00,$00,$04,$02,$00,$03,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_ItemBackColor;
const
  DispInfo: array[0..8] of Byte = ($6D,$00,$00,$00,$03,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_ItemBackColor;
const
  DispInfo: array[0..9] of Byte = ($6D,$00,$00,$00,$00,$04,$02,$00,$03,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_ItemEditText;
const
  DispInfo: array[0..8] of Byte = ($6E,$00,$00,$00,$02,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_ItemEditText;
const
  DispInfo: array[0..9] of Byte = ($6E,$00,$00,$00,$00,$04,$02,$00,$03,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_ItemFontBold;
const
  DispInfo: array[0..8] of Byte = ($6F,$00,$00,$00,$0B,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_ItemFontBold;
const
  DispInfo: array[0..9] of Byte = ($6F,$00,$00,$00,$00,$04,$02,$00,$03,$0B);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_ItemFontItalic;
const
  DispInfo: array[0..8] of Byte = ($70,$00,$00,$00,$0B,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_ItemFontItalic;
const
  DispInfo: array[0..9] of Byte = ($70,$00,$00,$00,$00,$04,$02,$00,$03,$0B);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_ItemFontName;
const
  DispInfo: array[0..8] of Byte = ($71,$00,$00,$00,$08,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_ItemFontName;
const
  DispInfo: array[0..9] of Byte = ($71,$00,$00,$00,$00,$04,$02,$00,$03,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_ItemFontSize;
const
  DispInfo: array[0..8] of Byte = ($72,$00,$00,$00,$02,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_ItemFontSize;
const
  DispInfo: array[0..9] of Byte = ($72,$00,$00,$00,$00,$04,$02,$00,$03,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_ItemFontStrike;
const
  DispInfo: array[0..8] of Byte = ($73,$00,$00,$00,$0B,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_ItemFontStrike;
const
  DispInfo: array[0..9] of Byte = ($73,$00,$00,$00,$00,$04,$02,$00,$03,$0B);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_ItemFontUnder;
const
  DispInfo: array[0..8] of Byte = ($74,$00,$00,$00,$0B,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_ItemFontUnder;
const
  DispInfo: array[0..9] of Byte = ($74,$00,$00,$00,$00,$04,$02,$00,$03,$0B);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_ItemForeColor;
const
  DispInfo: array[0..8] of Byte = ($75,$00,$00,$00,$03,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_ItemForeColor;
const
  DispInfo: array[0..9] of Byte = ($75,$00,$00,$00,$00,$04,$02,$00,$03,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_ItemIntValue;
const
  DispInfo: array[0..8] of Byte = ($76,$00,$00,$00,$02,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_ItemIntValue;
const
  DispInfo: array[0..9] of Byte = ($76,$00,$00,$00,$00,$04,$02,$00,$03,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_ItemLngValue;
const
  DispInfo: array[0..8] of Byte = ($77,$00,$00,$00,$03,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_ItemLngValue;
const
  DispInfo: array[0..9] of Byte = ($77,$00,$00,$00,$00,$04,$02,$00,$03,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_ItemMark;
const
  DispInfo: array[0..8] of Byte = ($78,$00,$00,$00,$03,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_ItemMark;
const
  DispInfo: array[0..9] of Byte = ($78,$00,$00,$00,$00,$04,$02,$00,$03,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_ItemMultiLine;
const
  DispInfo: array[0..8] of Byte = ($79,$00,$00,$00,$02,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_ItemMultiLine;
const
  DispInfo: array[0..9] of Byte = ($79,$00,$00,$00,$00,$04,$02,$00,$03,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_ItemParentBM;
const
  DispInfo: array[0..8] of Byte = ($7A,$00,$00,$00,$03,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_ItemParentBM;
const
  DispInfo: array[0..9] of Byte = ($7A,$00,$00,$00,$00,$04,$02,$00,$03,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_ItemSngValue;
const
  DispInfo: array[0..8] of Byte = ($7B,$00,$00,$00,$04,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_ItemSngValue;
const
  DispInfo: array[0..9] of Byte = ($7B,$00,$00,$00,$00,$04,$02,$00,$03,$04);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_ItemSorted;
const
  DispInfo: array[0..8] of Byte = ($7C,$00,$00,$00,$02,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_ItemSorted;
const
  DispInfo: array[0..9] of Byte = ($7C,$00,$00,$00,$00,$04,$02,$00,$03,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_ItemStrValue;
const
  DispInfo: array[0..8] of Byte = ($7D,$00,$00,$00,$08,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_ItemStrValue;
const
  DispInfo: array[0..9] of Byte = ($7D,$00,$00,$00,$00,$04,$02,$00,$03,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_ItemType;
const
  DispInfo: array[0..8] of Byte = ($7E,$00,$00,$00,$02,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_ItemType;
const
  DispInfo: array[0..9] of Byte = ($7E,$00,$00,$00,$00,$04,$02,$00,$03,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_List;
const
  DispInfo: array[0..8] of Byte = ($7F,$00,$00,$00,$08,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_List;
const
  DispInfo: array[0..9] of Byte = ($7F,$00,$00,$00,$00,$04,$02,$00,$03,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_ListCountEx;
const
  DispInfo: array[0..8] of Byte = ($80,$00,$00,$00,$03,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_ListCountEx;
const
  DispInfo: array[0..9] of Byte = ($80,$00,$00,$00,$00,$04,$02,$00,$03,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_LoadAndAdd;
const
  DispInfo: array[0..8] of Byte = ($81,$00,$00,$00,$02,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_LoadAndAdd;
const
  DispInfo: array[0..9] of Byte = ($81,$00,$00,$00,$00,$04,$02,$00,$03,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_LoadAndInsert;
const
  DispInfo: array[0..8] of Byte = ($82,$00,$00,$00,$02,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_LoadAndInsert;
const
  DispInfo: array[0..9] of Byte = ($82,$00,$00,$00,$00,$04,$02,$00,$03,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_MarkTag;
const
  DispInfo: array[0..8] of Byte = ($83,$00,$00,$00,$08,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_MarkTag;
const
  DispInfo: array[0..9] of Byte = ($83,$00,$00,$00,$00,$04,$02,$00,$03,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_Save;
const
  DispInfo: array[0..8] of Byte = ($84,$00,$00,$00,$02,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_Save;
const
  DispInfo: array[0..9] of Byte = ($84,$00,$00,$00,$00,$04,$02,$00,$03,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_SaveOne;
const
  DispInfo: array[0..8] of Byte = ($85,$00,$00,$00,$02,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_SaveOne;
const
  DispInfo: array[0..9] of Byte = ($85,$00,$00,$00,$00,$04,$02,$00,$03,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_SaveSub;
const
  DispInfo: array[0..8] of Byte = ($86,$00,$00,$00,$02,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_SaveSub;
const
  DispInfo: array[0..9] of Byte = ($86,$00,$00,$00,$00,$04,$02,$00,$03,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_SelItemIndex;
const
  DispInfo: array[0..8] of Byte = ($87,$00,$00,$00,$03,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_SelItemIndex;
const
  DispInfo: array[0..9] of Byte = ($87,$00,$00,$00,$00,$04,$02,$00,$03,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_SelectEx;
const
  DispInfo: array[0..8] of Byte = ($88,$00,$00,$00,$0B,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_SelectEx;
const
  DispInfo: array[0..9] of Byte = ($88,$00,$00,$00,$00,$04,$02,$00,$03,$0B);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_Selected;
const
  DispInfo: array[0..8] of Byte = ($89,$00,$00,$00,$0B,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_Selected;
const
  DispInfo: array[0..9] of Byte = ($89,$00,$00,$00,$00,$04,$02,$00,$03,$0B);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_Shift;
const
  DispInfo: array[0..8] of Byte = ($8A,$00,$00,$00,$02,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_Shift;
const
  DispInfo: array[0..9] of Byte = ($8A,$00,$00,$00,$00,$04,$02,$00,$03,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_TitleText;
const
  DispInfo: array[0..8] of Byte = ($8B,$00,$00,$00,$08,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_TitleText;
const
  DispInfo: array[0..9] of Byte = ($8B,$00,$00,$00,$00,$04,$02,$00,$03,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_TitleVisible;
const
  DispInfo: array[0..8] of Byte = ($8C,$00,$00,$00,$0B,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_TitleVisible;
const
  DispInfo: array[0..9] of Byte = ($8C,$00,$00,$00,$00,$04,$02,$00,$03,$0B);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_TitleWidth;
const
  DispInfo: array[0..8] of Byte = ($8D,$00,$00,$00,$04,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_TitleWidth;
const
  DispInfo: array[0..9] of Byte = ($8D,$00,$00,$00,$00,$04,$02,$00,$03,$04);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_FullPath;
const
  DispInfo: array[0..8] of Byte = ($8E,$00,$00,$00,$08,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_FullPath;
const
  DispInfo: array[0..9] of Byte = ($8E,$00,$00,$00,$00,$04,$02,$00,$03,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_FileDP;
const
  DispInfo: array[0..8] of Byte = ($8F,$00,$00,$00,$02,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_FileDP;
const
  DispInfo: array[0..9] of Byte = ($8F,$00,$00,$00,$00,$04,$02,$00,$02,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

function TTListPro.Get_ItemPMPicType;
const
  DispInfo: array[0..8] of Byte = ($90,$00,$00,$00,$02,$02,$01,$00,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TTListPro.Set_ItemPMPicType;
const
  DispInfo: array[0..9] of Byte = ($90,$00,$00,$00,$00,$04,$02,$00,$03,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure Register;
begin
  RegisterComponents('OCX', [TTListPro]);
end;

end.
